/*
**	$Id: IOFile.hpp 1.4 1995/10/13 11:43:06 olsen Exp olsen $
**
**	:ts=4
*/

/*
 * Copyright  1995 by Olaf Barthel, All Rights Reserved
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHORS ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO
 * EVENT SHALL THE AUTHORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
 * OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
 * OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
 * ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * This software has not been validated by the ``Bundesamt fuer Zulassungen in
 * der Telekommunikation'' of the ``Deutsche Bundepost Telekom'' and thus
 * must not be used for accessing the BTX-Network of the Telekom in Germany.
 *
 * Diese Software hat keine Zulassung durch das Bundesamt fuer Zulassungen in
 * der Telekommunikation der Deutschen Bundespost Telekom und darf daher nicht
 * am Netz der Deutschen Bundespost Telekom in Deutschland betrieben werden.
 */

#ifndef _IOFILE_HPP
#define _IOFILE_HPP 1

/****************************************************************************/

#include <dos/dos.h>

#include <string.h>
#include <stdio.h>

/****************************************************************************/

#ifndef _TYPES_HPP
#include "Types.hpp"
#endif

#ifndef _IOCHANNEL_HPP
#include "IOChannel.hpp"
#endif

/****************************************************************************/

class IOFile : public IOChannel
{
	public:

		IOFile();
		~IOFile();

		LONG Open(CONST STRPTR Channel,ULONG Unit=0,ULONG Baud=0,BOOL RTS_CTS=-1);
		VOID Close(VOID);

		LONG GetChar(LONG Timeout=0);
		VOID PutChar(UBYTE Char) {}
		VOID PutString(CONST STRPTR String,LONG Len=-1) {};

		LONG GetCharDirect(LONG Timeout=0) { return(GetChar(Timeout)); };
		VOID PutCharDirect(UBYTE Char) { PutChar(Char); };
		VOID PutStringDirect(CONST STRPTR String,LONG Len=-1) { PutString(String,Len); };

		VOID Flush(VOID) {};

		LONG Waiting(VOID);

		ULONG WaitMask(VOID) { return(NULL); }

	private:

		BPTR FileHandle;
		LONG Size;
		LONG BytesRead;
};

#endif	// _IOFILE_HPP
